/* 
 * Copyright (C) 2004 Darren Hutchinson (dbh@gbdt.com.au)
 * 
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or (at your
 * option) any later version.
 *
 * This program is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
 * or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public
 * License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this software; see the file COPYING.  If not, write to
 * the Free Software Foundation, Inc., 59 Temple Place - Suite 330, Boston,
 * MA 02111-1307, USA. 
 *
 * $Id: driver.h,v 1.3 2004/08/28 05:53:09 dbh Exp $
 */

#ifndef _DRIVER_H_
#define _DRIVER_H_

/* This file contains the interface for the actual stepper motor driver */

/* Bit use to connect to the "magic" relay that determines which
 * set ot RA coils are connected. This allows low current operation when
 * not slewing at high speed
 */
#define MAGIC_PORT      PORTB
#define MAGIC_DDR       DDRB
#define MAGIC_BITS      (_BV(PB4) | _BV(PB1))   // EQ6 and HEQ5

/* Interface prototypes */
void driverInit(void);

#endif /* _DRIVER_H_ */

