/* 
 * Copyright (C) 2004 Darren Hutchinson (dbh@gbdt.com.au)
 * 
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or (at your
 * option) any later version.
 *
 * This program is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
 * or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public
 * License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this software; see the file COPYING.  If not, write to
 * the Free Software Foundation, Inc., 59 Temple Place - Suite 330, Boston,
 * MA 02111-1307, USA. 
 *
 * $Id: eq6.h,v 1.11 2005/12/11 20:13:02 dbh Exp $
 */

#ifndef _EQ6_H_
#define _EQ6_H_

#include <inttypes.h>

/* Define the default clock rate used by the software
 * replacement firmware
 */
#define DEF_CLK_RATE	(16L * 1000L * 1000L)	// 16 MHz

#ifndef CLK_RATE
#define CLK_RATE        DEF_CLK_RATE
#endif /* CLK_RATE */

#define TMR2_FREQ       100     // Timer 2 frequency [Hz]. Used for debounce
                                // and pulseguide

/* Define the identification information returned in response to L200
 * :GV commands
 */
#define FIRMWARE_DATE       "DEC 10 2005"       /* MMM DD YYYY */
#define FIRMWARE_TIME       "00:00:00"          /* HH:MM:SS */
#define FIRMWARE_REV        "07.0"              /* nn.n */
#define PRODUCT_NAME        "EQ6 GBDT"

#endif /* _EQ6_H_ */
