/* 
 * Copyright (C) 2004 Darren Hutchinson (dbh@gbdt.com.au)
 * 
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or (at your
 * option) any later version.
 *
 * This program is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
 * or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public
 * License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this software; see the file COPYING.  If not, write to
 * the Free Software Foundation, Inc., 59 Temple Place - Suite 330, Boston,
 * MA 02111-1307, USA. 
 *
 * $Id: pguide.h,v 1.3 2004/05/11 04:12:45 dbh Exp $
 */
#ifndef _PGUIDE_H_
#define _PGUIDE_H_

/* This file has the definitions used to poll the parallel guiding input
 * pins.
 *
 * These pins are pulled high by the internal CPU pullups and should be
 * driven low by the guiding input
 */
#define GUIDE_PORT      PORTD
#define GUIDE_PIN       PIND
#define GUIDE_DDR       DDRD

#define G_UP            PD4
#define G_DN            PD5
#define G_RT            PD6
#define G_LT            PD7

/* Define the polling rate (in 100 Hz increments)
 */
#define GUIDE_RATE      1       // 10 ms debounce

/* Prototypes */
void pguideInit(void);
void pguideInt(void);

#endif /* _PGUIDE_H_ */
