/* 
 * Copyright (C) 2004 Darren Hutchinson (dbh@gbdt.com.au)
 * 
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or (at your
 * option) any later version.
 *
 * This program is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
 * or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public
 * License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this software; see the file COPYING.  If not, write to
 * the Free Software Foundation, Inc., 59 Temple Place - Suite 330, Boston,
 * MA 02111-1307, USA. 
 *
 * $Id: serial.h,v 1.5 2004/12/07 06:36:27 dbh Exp $
 */

#ifndef _SERIAL_H_
#define _SERIAL_H_

/* Define the constants for the guiding input
 */
#define GUIDE_BAUD      9600

/* Functions in serial.c */
void serialInit(void);
char serialTx(char *pStr);
void rxProcessing(void);

void print16(uint16_t num);
void print32(uint32_t num);

/* Global timer for pulseguide */
extern volatile uint16_t raPulseTime;
extern volatile uint16_t decPulseTime;

#endif /* _SERIAL_H_ */

